# Class VulkanVertexInputAttributeDescription.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanVertexInputAttributeDescription.Builder

Enclosing class:
  `VulkanVertexInputAttributeDescription`

public static final class VulkanVertexInputAttributeDescription.Builder extends Object
Builds instances of type `VulkanVertexInputAttributeDescription`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanVertexInputAttributeDescription`
  `build()`
  Builds a new `VulkanVertexInputAttributeDescription`.
  `final VulkanVertexInputAttributeDescription.Builder`
  `from(VulkanVertexInputAttributeDescriptionType instance)`
  Fill a builder with attribute values from the provided `VulkanVertexInputAttributeDescriptionType` instance.
  `final VulkanVertexInputAttributeDescription.Builder`
  `setBinding(int binding)`
  Initializes the value for the `binding` attribute.
  `final VulkanVertexInputAttributeDescription.Builder`
  `setFormat(VulkanFormat format)`
  Initializes the value for the `format` attribute.
  `final VulkanVertexInputAttributeDescription.Builder`
  `setLocation(int location)`
  Initializes the value for the `location` attribute.
  `final VulkanVertexInputAttributeDescription.Builder`
  `setOffset(int offset)`
  Initializes the value for the `offset` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanVertexInputAttributeDescription.Builder from(VulkanVertexInputAttributeDescriptionType instance)
    Fill a builder with attribute values from the provided `VulkanVertexInputAttributeDescriptionType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setLocation

    public final VulkanVertexInputAttributeDescription.Builder setLocation(int location)
    Initializes the value for the `location` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `location`.

    Parameters:
      `location` - The value for location
    Returns:
      `this` builder for use in a chained invocation

  - ### setBinding

    public final VulkanVertexInputAttributeDescription.Builder setBinding(int binding)
    Initializes the value for the `binding` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `binding`.

    Parameters:
      `binding` - The value for binding
    Returns:
      `this` builder for use in a chained invocation

  - ### setFormat

    public final VulkanVertexInputAttributeDescription.Builder setFormat(VulkanFormat format)
    Initializes the value for the `format` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `format`.

    Parameters:
      `format` - The value for format
    Returns:
      `this` builder for use in a chained invocation

  - ### setOffset

    public final VulkanVertexInputAttributeDescription.Builder setOffset(int offset)
    Initializes the value for the `offset` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `offset`.

    Parameters:
      `offset` - The value for offset
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanVertexInputAttributeDescription build()
    Builds a new `VulkanVertexInputAttributeDescription`.
    Returns:
      An immutable instance of VulkanVertexInputAttributeDescription
    Throws:
      `IllegalStateException` - if any required attributes are missing